'                   
'  
'  This file contains unpublished confidential  and proprietary information
'  of SQUARE ENIX CO.,LTD.  The contents of this file  may not be copied or
'  duplicated,  in whole or in part, by any means,  electronic or hardcopy,
'  without  the express  prior written permission  of  SQUARE ENIX CO.,LTD.
'  This copyright notice does not imply any actual or intended publication.
'  
'  $Id: CreateMirrorSkeleton.vbs,v 1.1 2004/12/21 10:03:28 ebisawa Exp $
'  
'  
'  
Option Explicit


Function RenameChildren( oOrgObj, oDstObj )
    Dim oOrgChildren, oDstChildren
    set oOrgChildren = oOrgObj.FindChildren
    set oDstChildren = oDstObj.FindChildren

    Dim i, mirrorName
    For i = 0 to oOrgChildren.count - 1
        mirrorName = GetMirrorName( oOrgChildren(i).Name )
        SetValue oDstChildren(i).Name&".Name", mirrorName
    Next
End Function

Function GetMirrorName( objName )
    Dim prefix
    prefix = Left( objName, 2 )
    If prefix = "L_" Then
        GetMirrorName = Replace( objName, "L_", "R_", 1, 1, vbTextCompare )
        Exit Function
    End If
    If prefix = "R_" Then
        GetMirrorName = Replace( objName, "R_", "L_", 1, 1, vbTextCompare )
        Exit Function
    End If
    If prefix = "l_" Then
        GetMirrorName = Replace( objName, "l_", "r_", 1, 1, vbTextCompare )
        Exit Function
    End If
    If prefix = "r_" Then
        GetMirrorName = Replace( objName, "r_", "l_", 1, 1, vbTextCompare )
        Exit Function
    End If

    prefix = Left( objName, 3 )
    If prefix = "LF_" Then
        GetMirrorName = Replace( objName, "LF_", "RF_", 1, 1, vbTextCompare )
        Exit Function
    End If
    If prefix = "RF_" Then
        GetMirrorName = Replace( objName, "RF_", "LF_", 1, 1, vbTextCompare )
        Exit Function
    End If
    If prefix = "LB_" Then
        GetMirrorName = Replace( objName, "LB_", "RB_", 1, 1, vbTextCompare )
        Exit Function
    End If
    If prefix = "RB_" Then
        GetMirrorName = Replace( objName, "RB_", "LB_", 1, 1, vbTextCompare )
        Exit Function
    End If

    If prefix = "lf_" Then
        GetMirrorName = Replace( objName, "lf_", "rf_", 1, 1, vbTextCompare )
        Exit Function
    End If
    If prefix = "rf_" Then
        GetMirrorName = Replace( objName, "rf_", "lf_", 1, 1, vbTextCompare )
        Exit Function
    End If
    If prefix = "lb_" Then
        GetMirrorName = Replace( objName, "lb_", "rb_", 1, 1, vbTextCompare )
        Exit Function
    End If
    If prefix = "rb_" Then
        GetMirrorName = Replace( objName, "rb_", "lb_", 1, 1, vbTextCompare )
        Exit Function
    End If

    ' Ȃ̂ŁÂ܂܂̖OԂ
    GetMirrorName = objName
End Function

Function ParseChild( oObj, oColl )
    Dim oChildren
    set oChildren = oObj.Children

    Dim posx
    posx = GetValue( oObj.Name & ".kine.global.posx" )
    If posx < 0.001 and posx > -0.001 Then
        ' S̏ꍇ́Aq
        Dim oChild
        For Each oChild In oChildren
'            LogMessage oObj.name & " -> " & oChild.name
            ParseChild oChild, oColl
        Next
    Else
        ' SȊOł΁ARNVɒǉ
        oColl.add oObj
    End If
End Function






function XSILoadPlugin( in_reg )
	in_reg.Author = "v3"
	in_reg.Major = 1
	in_reg.Minor = 0

	in_reg.RegisterCommand "CreateMirrorSkeleton","CreateMirrorSkeleton"
	'RegistrationInsertionPoint - do not remove this line

	XSILoadPlugin = true
end function

function XSIUnloadPlugin( in_reg )
	XSIUnloadPlugin = true
end function

function CreateMirrorSkeleton_Init( ctxt )
	dim oCmd
	set oCmd = ctxt.Source
	oCmd.Description = ""
	oCmd.ReturnValue = true

	CreateMirrorSkeleton_Init = true
end function

function CreateMirrorSkeleton_Execute(  )

	dim tpc
	tpc = TechPluginCertification( "CreateMirrorSkeleton", "1.2" )
	if tpc <> True then
		' false ɂƗvȂG[bZ[Wô true ƂB
        exit function
	end if

    Dim oSel, s
    Dim oColl
    set oColl = CreateObject( "xsi.Collection" )
    For Each s In selection
        ParseChild s, oColl
    Next

    Dim oDupColl
    set oDupColl = CreateObject( "xsi.Collection" )
    Dim c
    For Each c In oColl
        Dim oDupSkel
        set oDupSkel = DuplicateSymmetry( "B:"&c.Name, True, True, 1, 0, 0, 0, True )
        Dim x, mirrorName
        For Each x In oDupSkel
            oDupColl.add x
            mirrorName = GetMirrorName( c.Name )
            SetValue x.Name&".Name", mirrorName
            RenameChildren c, x
        Next
    Next

    DeselectAll
    For Each c In oDupColl
        LogMessage c.type
        AddToSelection c, siSelectBranch
    Next

	CreateMirrorSkeleton_Execute = true
end function

